#!../../bin/linux-x86/example
#cd "$(INSTALL)"
< envPaths
cd ${TOP}

#cd "/dls_sw/work/R3.14.12.2/support/Hy8424ip-asyn/2-3/example"

#$(LINUX_ONLY)epicsEnvSet(EPICS_CA_REPEATER_PORT,"6065")
#$(LINUX_ONLY)epicsEnvSet(EPICS_CA_SERVER_PORT,"6064")

# Load binaries on architectures that need to do so.
# VXWORKS_ONLY, LINUX_ONLY and RTEMS_ONLY are macros that resolve
# to a comment symbol on architectures that are not the current
# build architecture, so they can be used liberally to do architecture
# specific things. Alternatively, you can include an architecture
# specific file.
#$(VXWORKS_ONLY)ld < bin/$(ARCH)/example.munch

#ld < bin/vxWorks-ppc604_long/example.munch

#$(VXWORKS_ONLY)epicsEnvSet(EPICS_CA_REPEATER_PORT,"6065")
#$(VXWORKS_ONLY)epicsEnvSet(EPICS_CA_SERVER_PORT,"6064")
epicsEnvSet(EPICS_CA_MAX_ARRAY_BYTES,"3000000")
epicsEnvSet(EPICS_CA_AUTO_ADDR_LIST, "NO")
epicsEnvSet(EPICS_CA_ADDR_LIST, "172.23.81.195")
 
## Register all support components
dbLoadDatabase("dbd/example.dbd")
example_registerRecordDeviceDriver(pdbbase)


# For PCI/Linux IOC, use
ipacAddHyLinux9010("99,1")

# For PCI/RTEMS IOC, use
#ipacAddHyRTEMS9010("1,4,0")

# For VME/VxWorks
#IPAC3 = ipacAddHy8002("3,2,IPMEM=2")  

# For VME/Linux/Conccurent Processor
#ipacAddHy8002Concurrent("4,2,IPMEM=2")
#
############ This init is needed for all modes #############
#int Hy8424AsynInit(char *portName,  "ADC8424"
#  int carrierNum, 	0
#  int ipSlotNum,   0
#  int vectorNum,   88
#  int clockRate,   9 (1kHz) 1~18 = 1Hz ~ 1MHz
#  int extClock,    0=internal, 1=external
#  int range,       0=+/-10V, 1=+/-5V
#Hy8424AsynInit("ADC8424", IPAC3, 0, 88, 17, 0, 0)
Hy8424AsynInit("ADC8424", 0, 5, 88, 9, 0, 0)
#
#int Hy8424ContinueMode(char *portName,  "ADC8424"
#  int average,     1000
#  int fastADC,     1=fast ADC, 0=mca & EPID support
#Hy8424ContinueMode("ADC8424", 1000, 1)
#
#int Hy8424TriggerMode(char *portName,  "ADC8424"
#  int samples,     1000
#  int average,     1000
#  int offset,   	Offset to start collecting after trigger
#  int fastADC,     1=fast ADC, 0=mca & EPID support
#  int triggerEdge) 0
Hy8424TriggerMode("ADC8424", 10, 1000, 0, 1, 0)
#
#int Hy8424GatedMode(char *portName,  "ADC8424"
#  int average,     1
#  int offset,   	offset to start collecting after trigger
#  int fastADC,     1=fast ADC, 0=mca & EPID support
#Hy8424GatedMode("ADC8424", 1, 10, 1)
#
# int Hy8424SimpleTRMode(char *portName, int sample, double delay, double thresholdlow0, 
#		double thresholdhigh0, double thresholdlow1, double thresholdhigh1,	
#		double thresholdlow2, double thresholdhigh2, double thresholdlow3, 
#		double thresholdhigh3,  int outputEdge, int stopInEdge)
# portName   = asyn port name for this port
# samples,     	256k - delay*clockrate
# delay,     	in second
# thresholdlow0  =low threshold channel 0
# thresholdhigh0 = upper threshold channel 0.
# thresholdlow1  =low threshold channel 1
# thresholdhigh1 = upper threshold channel 1.
# thresholdlow2  =low threshold channel 2
# thresholdhigh2 = upper threshold channel 2.
# thresholdlow3  =low threshold channel 3
# thresholdhigh3 = upper threshold channel 3.
# outputEdge  	=trigger out edge. 0=rising, 1=falling
# stopInEdge  	=stop in edge. 0=rising, 1=falling
#Hy8424SimpleTRMode("ADC8424", 10000, 0.0, 1, -4, 4, -0, 6, -2, 5, -3, 0, 0)
#
# int Hy8424VoltageTRMode(char *portName, int sample, int VTChannel, double thresholdlow, 
#		double thresholdhigh, int buffersize, int outputEdge, int stopInEdge)
# portName   	= asyn port name for this port
# samples,     	256k - buffersize
# VTChannel  	=voltage trigger channel. 0~3
# thresholdlow  =low threshold for VTChannel
# thresholdhigh =upper threshold for VTChannel.
# buffersize	=circular buffer size. 0~65535
# outputEdge  	=trigger out edge. 0=rising, 1=falling
# stopInEdge  	=stop in edge. 0=rising, 1=falling
#Hy8424VoltageTRMode("ADC8424", 10000, 0, 1, -4, 1000, 0, 0)
#
## Load record instances
dbLoadRecords("db/8424.db","P=CARD2,PORT=ADC8424")
dbLoadRecords("db/8424_CS.db","P=CARD2,PORT=ADC8424")
#dbLoadRecords("db/8424_transient_recorder.db","P=CARD2,PORT=ADC8424")
#
# set trace output level for asyn port "ADC8424"
# Level: 0x01 = Errors only
# asynSetTraceMask arguments:
#  * asyn port
#  * address of that asynport (i.e. channel number)
#  * verbosity level: 
#                     0x01: error, 
#                     0x11: errors, warnings and debug
#                     0x00: silent
asynSetTraceMask( "ADC8424", 0, 0x00 )  
# all driver level messages

iocInit()

